#include "HAHead.hlsl"

//#define BLENDDIFFUSE0TEXTURE "FbeB.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDDIFFUSE1TEXTURE "FbeA.png"
#define BLENDDIFFUSE1TEXTURE_X 256
#define BLENDDIFFUSE1TEXTURE_Y 256
//#define BLENDSPECULAR0TEXTURE "_.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 256
#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDDIFFUSE1TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.8;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTURE
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}



float3 BlendAddSphere(float3 color, BlendParameters parameters)
{


	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuOAQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAdRWZmZWN0RG9jdW1lbnQuRGlmZnVzZUVudHJpZXNA
// HA2 CkJsZW5kRW50cnkECUlzRW5hYmxlZJgFRmFsc2UECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0
// HA2 ZXJYmBNFeHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmBNFeHRlbmRlZExpZ2h0Tm9ybWFs
// HA2 QBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyY
// HA2 A1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3Jl
// HA2 ZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQ
// HA2 YXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5
// HA2 LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgU5Y+L5oG144GG44Gd
// HA2 5b2xQi5wbmcEBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UwVGV4dHVyZQEB
// HA2 AUAKQmxlbmRFbnRyeQQJSXNFbmFibGVkmARUcnVlBApJc1NwZWN1bGFymAVGYWxzZQQKUGFyYW1l
// HA2 dGVyWJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRMaWdodE5vcm1h
// HA2 bEASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVs
// HA2 mANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdy
// HA2 ZWVuBA1UYXJnZXRDaGFubmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQ
// HA2 UGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRy
// HA2 eS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYFOWPi+aBteOBhuOB
// HA2 neW9sUEucG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgUQmxlbmREaWZmdXNlMVRleHR1cmUB
// HA2 AQEBQBpFZmZlY3REb2N1bWVudC5FZGdlRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmARU
// HA2 cnVlBApJc1NwZWN1bGFymAVGYWxzZQQKUGFyYW1ldGVyWJgETm9uZQQKUGFyYW1ldGVyWZgETm9u
// HA2 ZUASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmAdSZXBsYWNlBBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyY
// HA2 A1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3Jl
// HA2 ZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQ
// HA2 YXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5
// HA2 LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZagEBEtpbmSYA1JnYgQM
// HA2 VmFyaWFibGVOYW1lmBFCbGVuZEVkZ2UwVGV4dHVyZQEBAQFAHkVmZmVjdERvY3VtZW50LlNwZWN1
// HA2 bGFyRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgEVHJ1
// HA2 ZQQKUGFyYW1ldGVyWJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRM
// HA2 aWdodE5vcm1hbEASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25A
// HA2 C0JsZW5kQWN0aW9uBARLaW5kmANBZGQEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hh
// HA2 bm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgFR3Jl
// HA2 ZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFyYW1l
// HA2 dGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0
// HA2 dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYDumPoemdol/ogowucG5nBARL
// HA2 aW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgVQmxlbmRTcGVjdWxhcjBUZXh0dXJlAQEBAQE=