#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTURE "FbB.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDDIFFUSE1TEXTURE "FbA.png"
#define BLENDDIFFUSE1TEXTURE_X 256
#define BLENDDIFFUSE1TEXTURE_Y 256
//#define BLENDSPECULAR0TEXTURE "_.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 256
#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDDIFFUSE1TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.8;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTURE
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}



float3 BlendAddSphere(float3 color, BlendParameters parameters)
{


	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuOAQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAdRWZmZWN0RG9jdW1lbnQuRGlmZnVzZUVudHJpZXNA
// HA2 CkJsZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRl
// HA2 cliYE0V4dGVuZGVkTGlnaHROb3JtYWwEClBhcmFtZXRlclmYE0V4dGVuZGVkTGlnaHROb3JtYWxA
// HA2 EkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlv
// HA2 bgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgD
// HA2 UmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVl
// HA2 bgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBh
// HA2 cmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnku
// HA2 VGV4dHVyZUAHVGV4dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmA7lj4vmgbXogoxCLnBu
// HA2 ZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJsZW5kRGlmZnVzZTBUZXh0dXJlAQEBQApCbGVu
// HA2 ZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0ZXJYmBNF
// HA2 eHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmBNFeHRlbmRlZExpZ2h0Tm9ybWFsQBJCbGVu
// HA2 ZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtp
// HA2 bmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFA
// HA2 C0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRh
// HA2 cmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0
// HA2 ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1
// HA2 cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgO5Y+L5oG16IKMQS5wbmcEBEtp
// HA2 bmSYA1JnYgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UxVGV4dHVyZQEBAQFAGkVmZmVjdERv
// HA2 Y3VtZW50LkVkZ2VFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3Vs
// HA2 YXKYBUZhbHNlBApQYXJhbWV0ZXJYmAROb25lBApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVudHJ5
// HA2 LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYB1Jl
// HA2 cGxhY2UEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRB
// HA2 Y3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hh
// HA2 bm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5u
// HA2 ZWyYBEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4
// HA2 dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lqAQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWY
// HA2 EUJsZW5kRWRnZTBUZXh0dXJlAQEBAUAeRWZmZWN0RG9jdW1lbnQuU3BlY3VsYXJFbnRyaWVzQApC
// HA2 bGVuZEVudHJ5BAlJc0VuYWJsZWSYBUZhbHNlBApJc1NwZWN1bGFymARUcnVlBApQYXJhbWV0ZXJY
// HA2 mBNFeHRlbmRlZExpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmBNFeHRlbmRlZExpZ2h0Tm9ybWFsQBJC
// HA2 bGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24E
// HA2 BEtpbmSYA0FkZAQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtC
// HA2 bGVuZEFjdGlvbgQES2luZJgDQWRkBBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hh
// HA2 bm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgDQWRkBBBQYXJhbWV0ZXJDaGFubmVsmARC
// HA2 bHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUE
// HA2 BE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgO6Y+h6Z2iX+iCjC5wbmcEBEtpbmSYA1JnYgQMVmFy
// HA2 aWFibGVOYW1lmBVCbGVuZFNwZWN1bGFyMFRleHR1cmUBAQEBAQ==