#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTURE "gU_B.png"
#define BLENDDIFFUSE0TEXTURE_X 256
#define BLENDDIFFUSE0TEXTURE_Y 256
#define BLENDDIFFUSE1TEXTURE "gU_A.png"
#define BLENDDIFFUSE1TEXTURE_X 256
#define BLENDDIFFUSE1TEXTURE_Y 256
//#define BLENDSPECULAR0TEXTURE "_.png"
#define BLENDSPECULAR0TEXTURE_X 256
#define BLENDSPECULAR0TEXTURE_Y 1
#define BLENDEDGE0TEXTURE
#define BLENDEDGE0TEXTURE_X 256
#define BLENDEDGE0TEXTURE_Y 256
//#define USE_LOCALSHADOW
#define USE_EXCELLENTSHADOW
#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define USE_NORMALMAP
#ifdef BLENDDIFFUSE0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDDIFFUSE1TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTURE, Clamp, Clamp)
#endif
#ifdef BLENDSPECULAR0TEXTURE
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTURE, Clamp, Clamp)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	string UIWidget = "Numeric";
	float UIMin = 0;
	float UIMax = 2;
> = 0.6;

float NormalMapResolution
<
string UIName = "@}bv𑜓x";
string UIWidget = "Numeric";
float UIMin = 0;
float UIMax = 10;
> = 1;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTURE
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTURE
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.ExtendedLightNormal, parameters.ExtendedLightNormal));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTURE
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.LightNormal, 0));
	
	target.r += value.r * value.a;
	target.g += value.g * value.a;
	target.b += value.b * value.a;
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}



float3 BlendAddSphere(float3 color, BlendParameters parameters)
{


	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTURE
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNgQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQTTm9ybWFsTWFwUmVzb2x1dGlvboIEEE5vcm1hbE1hcFRleHR1cmWoBBBT
// HA2 ZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdpdGhUb29umAVGYWxzZQQN
// HA2 U2hhZGVUb29ubGVzc5gEVHJ1ZQQSVXNlRXhjZWxsZW50U2hhZG93mARUcnVlBA5Vc2VMb2NhbFNo
// HA2 YWRvd5gFRmFsc2UEDFVzZU5vcm1hbE1hcJgFRmFsc2UIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rh
// HA2 ci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdlbmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNy
// HA2 b3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAdRWZmZWN0RG9jdW1lbnQuRGlmZnVzZUVudHJpZXNA
// HA2 CkJsZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRl
// HA2 cliYE0V4dGVuZGVkTGlnaHROb3JtYWwEClBhcmFtZXRlclmYE0V4dGVuZGVkTGlnaHROb3JtYWxA
// HA2 EkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlv
// HA2 bgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgD
// HA2 UmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVl
// HA2 bgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBh
// HA2 cmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnku
// HA2 VGV4dHVyZUAHVGV4dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBLmi6HmlaNf6IKM55m9
// HA2 Qi5wbmcEBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UwVGV4dHVyZQEBAUAK
// HA2 QmxlbmRFbnRyeQQJSXNFbmFibGVkmARUcnVlBApJc1NwZWN1bGFymAVGYWxzZQQKUGFyYW1ldGVy
// HA2 WJgTRXh0ZW5kZWRMaWdodE5vcm1hbAQKUGFyYW1ldGVyWZgTRXh0ZW5kZWRMaWdodE5vcm1hbEAS
// HA2 QmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0aW9u
// HA2 BARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANS
// HA2 ZWQBQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVu
// HA2 BA1UYXJnZXRDaGFubmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFy
// HA2 YW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5U
// HA2 ZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYEuaLoeaVo1/ogoznmb1B
// HA2 LnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJsZW5kRGlmZnVzZTFUZXh0dXJlAQEBAUAa
// HA2 RWZmZWN0RG9jdW1lbnQuRWRnZUVudHJpZXNACkJsZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQK
// HA2 SXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliYBE5vbmUEClBhcmFtZXRlclmYBE5vbmVAEkJs
// HA2 ZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQE
// HA2 S2luZJgHUmVwbGFjZQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQB
// HA2 QAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1U
// HA2 YXJnZXRDaGFubmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1l
// HA2 dGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0
// HA2 dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWoBARLaW5kmANSZ2IEDFZhcmlh
// HA2 YmxlTmFtZZgRQmxlbmRFZGdlMFRleHR1cmUBAQEBQB5FZmZlY3REb2N1bWVudC5TcGVjdWxhckVu
// HA2 dHJpZXNACkJsZW5kRW50cnkECUlzRW5hYmxlZJgFRmFsc2UECklzU3BlY3VsYXKYBFRydWUEClBh
// HA2 cmFtZXRlcliYC0xpZ2h0Tm9ybWFsBApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVudHJ5LkFjdGlv
// HA2 bnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYA0FkZAQQUGFy
// HA2 YW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFjdGlvbgQES2lu
// HA2 ZJgDQWRkBBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtC
// HA2 bGVuZEFjdGlvbgQES2luZJgDQWRkBBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFu
// HA2 bmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9
// HA2 BAhGaWxlTmFtZZgR6Y+h6Z2iX+iCjOeZvS5wbmcEBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBVC
// HA2 bGVuZFNwZWN1bGFyMFRleHR1cmUBAQEBAQ==